/*
 * chainer.h
 *
 * Copyright (c) 1997-1999, 2000, 2001 Hajime Mochizuki <motizuki@jaist.ac.jp>
 *   Natural Language Processing Laboratory,
 *   Japan Advanced Institute of Science and Technology.
 *
 *
 * Use of this software is granted only for RESEARCH PURPOSES. 
 * Redistribution is granted as long as all copyright notices are retained.
 * Redistribution with modification is allowed provided that you make your 
 * modified version obviously distinguishable from the original one.  
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR 
 * IMPLIED WARRANTIES ARE DISCLAIMED.
 *
 *
 */
#ifndef __CHAINER_H_
#define __CHAINER_H_

#include "cmn.h"

/* FROM OPTION.H */
int IDLEVEL;                    /* ǰ idΥޥåǸ뿼 */
int USEIDLEVEL;                 /* j option */
int CHNMEM_THRESH;              /* İʾϢʤäCHAINȤ뤫 */
int SIMPLE_OUTPUT;
int ONLY_ONE_SENSE;
int VERBOSE;
/* FROM OPTION.H */

#define ON   1
#define OFF  0

/* for split1 */
#define SPLITREC1 100
#define SPLITFLD1 300

#define HASHSIZE 1001
#define HASHSIZE2   10001

#define YES 1
#define NO  0

#define RECORDSIZE  10000
#define WN          400          /* 1ʸñκ   */
#define WC          200          /* 1ñʸ         */
#define IDN         3000         /* ǰ id   */
#define IDC         200           /* 1Ĥγǰidκ */
#define SENSEMAXNUM 20           /* 1ñ20(ɤߤΰ㤤ޤ)  */
#define INFOMAXLEN  500          /* 1ñ1˴ؤĹ */

typedef struct _concepts {
    unsigned char     id[IDC];      /* ǰ id */
    int               entity[WN];   /* γǰid 1, otherwise 0 */
    struct _wordinfo *info[WN];
    int               sum;          /* γǰidñι׿ */
}CONCEPTS;

typedef unsigned char WORD;
typedef unsigned char JOSHI;

typedef struct _wordinfo {
    unsigned char info[SENSEMAXNUM*INFOMAXLEN]; /* <--- over runʤ? */
    unsigned char concept[IDC];
    int		  realsn;   /* ɲ99/07/02 */
    int		  realwn;   /* ɲ99/07/02 */
    int           infono;
    struct _wordinfo *next; /* ɲ 10/28 */
}WORDINFO;

typedef struct _position {
    unsigned char id[IDC];
    int           pos;           /* Ǥźֹ */
    int           lwn;           /* Ǹ˵Ͽ줿ֹ
				    (ƱֹǤIDΤ֤ɤ */
    struct _position *next_point;
}POSITION;

typedef struct _postoword {
    unsigned char word[WC];
    int           wordpos;
    struct _postoword *next_point; /* hash֤äΤ */
}POSTOWORD;

typedef struct _wordlist {
    struct _wordlist *backward_point;
    int               wordposition;
    int 	      wnum;
    unsigned char     word[WC];           /* ܷ ɽ */
    unsigned char     joshi[JOSHIMAXLEN]; /* ʤɤξ */
    unsigned char     joswd[JOSHIMAXLEN]; /* ɽ 01/04/29 ɲ */
    struct _wordlist *forward_point;      /* ñ */
}WORDLIST;

/* idlist黲Ȥ ñ줬ɤΤ褦ʸֹ桤ɤߤ򤷤Ƥ뤫
 * Ƥ
 */
typedef struct _winfolist {
    struct _winfolist *backward_point;
    unsigned char     wordinfo[SENSEMAXNUM*INFOMAXLEN];
    unsigned char     concept[IDC];  /* Ѥǰ*/
    struct _winfolist *forward_point;
}WINFOLIST;

/* text levelʸ̮ȤäۣäΤstack¸
 * stackѤΥ᥿ʹ¤
 */
typedef struct _stack {
    struct _stack  *upward_point;    /* ̥å */
    struct _wordlist *wordlist_top;  /* wordlistλϤޤ */
    struct _wordlist *wordlist_last; /* wordlistν */
    struct _idlist *idlist_top;      /* idlistλϤޤ */
    struct _idlist *idlist_last;     /* idlistν */
    struct _stack  *downward_point;  /* ̥å */
}STACK;

/*
 * ºݤ˳ƥå֤бIDѤι¤
 */
typedef struct _idlist {
    unsigned char      id[IDC];         /* idֹ */
    int                forcheck;        /* matchingcheck */
    struct _winfolist *winfolist_top;   /* θǸñ */
    struct _winfolist *winfolist_last;
    struct _idlist    *backward_point;  /* ƱؤΥݥ() */
    struct _idlist    *forward_point;   /* ƱؤΥݥ() */
}IDLIST;

POSITION  *position[HASHSIZE];
/*POSTOWORD *pos2word[HASHSIZE2];*/

STACK    *StackTopPoint; /* ᤷƤߤɡɤ */
			   

WORD      word[WN][WC];
JOSHI     joshi[WN][JOSHIMAXLEN];
JOSHI     joswd[WN][JOSHIMAXLEN];

WORDINFO *WordInfoStart, *WordInfoNow;  /* ɲ 10/28 */

int SPENDHASH;

#ifdef TXT_2_SUMMARY
typedef struct chn {
    unsigned char word[TERMMAXLEN];
    unsigned char con[TERMMAXLEN];
    int           sn;
    int           wn;
    unsigned char joshi[JOSHIMAXLEN];
}CHN;
#endif
#endif
