/*
 * chainer_th.c 
 *
 * Copyright (c) 1997-1999,2000,2001 Hajime Mochizuki <motizuki@jaist.ac.jp>
 *   Natural Language Processing Laboratory,
 *   Japan Advanced Institute of Science and Technology.
 *
 *
 * Use of this software is granted only for RESEARCH PURPOSES. 
 * Redistribution is granted as long as all copyright notices are retained.
 * Redistribution with modification is allowed provided that you make your 
 * modified version obviously distinguishable from the original one.  
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR 
 * IMPLIED WARRANTIES ARE DISCLAIMED.
 *
 * ŪϢΥץ theraurusѥ
 *
 * chasen 2.2.x     -e  
 * juman  3.61      -e
 * KNP              -tab   б
 *
 * ϤϷǲϷ̤ˤ롥 
 */
#include <config.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/* for CHAR_BIT */
#if defined(BSD44) || defined(DIGITAL)
#include <machine/limits.h>
#else
#include <limits.h>
#endif

/* #include <malloc.h>*/
#include "chainer.h"
/*#include "option.h"*/

#include "mrp2dat.h"
#include "nero.h"
/* #include "thesaurus.h"*/

#include "mrpfil.h" /* <--- add from 1.50.2 */

extern int wnum_total;
extern CONCEPTS      cwmatrix[300+1];   /* concept-word matrix */
int debug;

static char *pname;
char pfn[300];
/* char *mrf; */ /* ---> move this to mrpfil.h */
/* extern int filtermode;*/
extern struct patrash_files* patrash_preparation();
extern FILE* open_dic();
extern char* nd_cha2dat();
extern struct term_entry* make_c2d();
extern STACK* make_chain();
extern int ciw_sw;
/* extern int mrp_type; *//* extern int use_knp;*/
extern void chaining_preparation();

/*
 * option help
 */
void option_help ()
{
	fprintf (stderr, "Lexical Chainers version 1.50 -th-");
	fprintf (stderr, "   (c) 1997-1999,2000,2001 motizuki@jaist.ac.jp\n");
	fprintf (stderr, "usage: %s [options] < morphfile\n", pname);
	fprintf (stderr, "INPUT TYPE Default=-cha\n");
	fprintf (stderr, "  -knp     : KNP -tab Ϥ\n");
	fprintf (stderr, "  -cha     : ChaSen 2.2.x  -e Ϥ\n");
	fprintf (stderr, "  -jum     : Juman3.61     -e Ϥ\n");
	fprintf (stderr, "FILTER FILE\n");
	fprintf (stderr, "  -rule <filename> : ñꥹȤʤɤ򵭽Ҥfileλ\n");
	fprintf (stderr, "CHAIN CALCULATION\n");
        fprintf (stderr, "  -F <num> :filter mode Ϣʻλ Default=0\n");
        fprintf (stderr, "\t\t 0 . ̾ ư ƻ\n");
        fprintf (stderr, "\t\t 1 . ̾ ---- ƻ\n");
        fprintf (stderr, "\t\t 2 . ̾ ---- ------\n");
        fprintf (stderr, "\t\t 3 . ̾ ư ------\n");
        fprintf (stderr, "\t\t 4 . ---- ư ------\n");
        fprintf (stderr, "\t\t 5 . ---- ư ƻ\n");
        fprintf (stderr, "\t\t 6 . ---- ---- ƻ\n");
	fprintf (stderr, "  -i <num> :ǰؤΥ٥򲿥٥ޤǻѤ뤫\n");
	fprintf (stderr, "\t\t 0ϥ饹̤ Default=2 (1,2٥)\n");
	fprintf (stderr, "  -j <num> :ꤷ٥Ȥ\n");
	fprintf (stderr, "\t\t 0ϤΥץ̵ˤ Default=0\n");
	fprintf (stderr, "  -t <num> :ʾϢʤächainȤƽϤ뤫 Default=1\n");
	fprintf (stderr, "  -D <dicname>: Ѥ륷饹λ\n");
	fprintf (stderr, "OUTPUT TYPE\n");
	fprintf (stderr, "  -1       : ̤¿ξǤǽ1ɽ\n");
	fprintf (stderr, "  -V       : ˥åФ\n");
	fprintf (stderr, "  -W       : Ϣñʳ⥫Ȥ\n");
	fprintf (stderr, "  -h       : help\n");
	fprintf (stderr, "  -de      : debug mode\n");
	exit(1);
}

/*
 * option check
 */
void option_checking (argc, argv)
    int   argc;
    char *argv[];
{
	int i;
	char ppfn[200];

	/* option initialize */
	IDLEVEL       = 2;        /* ǰIDΤɤΥ٥Ȥ(0,1-3) */
	USEIDLEVEL    = 0;        /* j opt,  ɤΥ٥Ȥ */
	CHNMEM_THRESH = 1;        /* ʾǹ줿chianȤƽϤ뤫 */
	SIMPLE_OUTPUT = YES;       /* ץʽ */
	ONLY_ONE_SENSE= NO;       /* ¿Ǥ1 */
	VERBOSE       = OFF;      /* Υå(OFF) */
	filtermode    = 0;
	/* kadokawa */
	pname = argv[0];
	pfn[0] = '\0';
	mrf = NULL; /* rule fileλ꤬Ф */
	ciw_sw    = 0; /* ͭñʳֹ˥Ȥ뤫ɤ 0ʤ*/
	debug     = 0; /* debug mode */
	mrp_type  = 0; /* 0=ChaSen2.2.x, 1=KNP, 2=Juman*/

	argc--, argv++;

	while (argc>0 && *argv[0]=='-') {
		if (!strcmp(argv[0], "-i")) {
			argc--, argv++;
			IDLEVEL = atoi(argv[0]);
		} else if (!strcmp(argv[0],"-j")) {
			argc--, argv++;
			USEIDLEVEL = atoi(argv[0]);
		} else if (!strcmp(argv[0],"-t")) {
			argc--, argv++;
			CHNMEM_THRESH = atoi(argv[0]);
		} else if (!strcmp(argv[0],"-D")) {
			argc--, argv++;
			strcpy(pfn,argv[0]);
		} else if (!strcmp(argv[0],"-F")) {
			argc--, argv++;
			filtermode = atoi(argv[0]);
		} else if (!strcmp(argv[0], "-knp")) {
			/* use_knp = 1;*/
			mrp_type = 1;
		} else if (!strcmp(argv[0], "-cha")) {
			mrp_type = 0;
		} else if (!strcmp(argv[0], "-jum")) {
			mrp_type = 2;
		} else if (!strcmp(argv[0], "-rule")) {
			argc--, argv++;
			mrf = argv[0];
		} else if (!strcmp(argv[0],"-h")) {
			option_help();
		} else if (!strcmp(argv[0], "-W")) {
			ciw_sw=1;
		} else if (!strcmp(argv[0],"-1")) {
			ONLY_ONE_SENSE = YES;
		} else if (!strcmp(argv[0],"-s")) {
			SIMPLE_OUTPUT  = YES;
		} else if (!strcmp(argv[0],"-c")) {
			SIMPLE_OUTPUT  = NO;
		} else if (!strcmp(argv[0],"-V")) {
			VERBOSE        = YES;
		} else if (!strcmp(argv[0],"-de")) {
			debug = 1;
		} else {
			fprintf (stderr, "Invalid arg: %s\n", argv[0]);
			option_help();
		}
		argc--, argv++;
	}
	if (pfn[0]=='\0') {
		sprintf(pfn,"%s", DEF_THES); /* thesaurus.h */
	} else if (fopen_dic_check(pfn)==0) {
		sprintf(ppfn, "%s/%s", DEF_THES_PATH, pfn);
		if (fopen_dic_check(ppfn)==0) {
			fprintf (stderr, "饹 %s ޤ\n",ppfn);
			option_help();
		}
		sprintf(pfn, "%s", ppfn);
	}
}

/*
 * indirect method
 *  -knp .. mrp_type = 1 ξknp -tabνϤϤȤ
 *  -cha .. mrp_type = 0 ξChaSen2.2.x  -eνϤϤȤ
 *  -jum .. mrp_type = 2 ξJUMAN3.61    -eνϤϤȤ
 * 
 */
int main (argc, argv)
    int   argc;
    char *argv[];
{
	int  snum, wn, state, init, pwn, allmrp;
	char record[BUFSIZ], *cptr, *dptr;
	/*STACK *StackTopPoint; */ /* ѹ */
        struct patrash_answer_ptr *ptrr;
	struct patrash_files *pf;
	FILE *dic;

	option_checking (argc, argv);
	pf = patrash_preparation(pfn); /* patrashȤ */
	dic  = open_dic (pfn);
	chaining_preparation(); /* ޤȤƤޤächa2dat.c ˤ*/

	OUTPUTSW = 0;
	snum = 1;
	pwn=1; wn=0;
	state=0; init=1; allmrp=0; /* allrmp ǿ롥ѹ*/

	while (fgets(record, BUFSIZ, stdin) != NULL) {
		if (record[0]=='\n') continue;
		record[strlen(record)-1]='\0';
		if (strcmp(record, "EOS")==0) {
			if (VERBOSE) {
				fprintf (stderr, "SENTENCE %d\n", snum);
				if (snum==80) {
					PrintChains2( StackTopPoint );
					testest();
				}
			}
			wn=0;
			if (dptr!=NULL && dptr[0]!='\0') {
				StackTopPoint=
					make_chain(StackTopPoint, dptr);
			}
			state=0;
			init =1;
			snum++;
		} else if (mrp_type==1 &&  /* KNP -tab */
			   ((record[0] == '#' && record[1] == ' ' &&
			     record[2] == 'S') ||
			    (record[0] == '*' && record[1] == ' ')||
			    (record[0] == ';' && record[1] == ';'))) {
			; /* ⤷ʤ */
		} else {
			pwn=wn;
			if (debug) {
				fprintf (stderr, "pre%d wn%d %s\n", pwn, wn, record);
			}
			dptr=nd_cha2dat(record, snum, &wn, IDLEVEL,
					pf,dic,filtermode,state, init, mrp_type, mrf);
			init++;
			if (pwn==wn) {
				if (ciw_sw==1) wn++;
				state=0;
			} else	state=1;
			allmrp++;
		}
	}
	patrash_finish(pf);
	fclose(dic);

	/*	printf ("%d %d\n", wnum_total-1, snum-1); /* ɬ */
	printf ("%d %d %d\n", wnum_total-1, snum-1, allmrp); /* ɬ <-ѹ */
	PrintChains( StackTopPoint );
}
