/*
 * Copyright (c) 1999-2000,2001 Hajime Mochizuki <motizuki@jaist.ac.jp>
 *   Natural Language Processing Laboratory,
 *   Japan Advanced Institute of Science and Technology.
 *
 *
 * Use of this software is granted only for RESEARCH PURPOSES. 
 * Redistribution is granted as long as all copyright notices are retained.
 * Redistribution with modification is allowed provided that you make your 
 * modified version obviously distinguishable from the original one.  
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR 
 * IMPLIED WARRANTIES ARE DISCLAIMED.
 *
 */
#include <config.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include "patrash.h"

int moto_cell_num = 0;
int moto_cell_id  = 0;
int   debug;
struct moto_cell     *node_moto_cell=NULL;
struct patrash_array *wanwan;

off_t  pointerA;
off_t  pointerB;

#ifndef _MERROR_
#define _MERROR_
void merror (comment)
     char *comment;
{
	fprintf (stderr, "malloc error for %s\n", comment);
	exit(1);
}
#endif

void collect_moto_cell (p, n, d)
    struct moto_cell *p, *n;
    int    d;
{
	struct moto_cell *q, *r, *s;

	if ( n==NULL) return;
	if ((n->zero==NULL && n->one==NULL) || (n->ck==1))  return;
	if ( n->zero!=NULL && n->one==NULL) {
		if (n->file==-1) { /* äƤ */
			q = n;
			r = n->zero;
			if (d==0) {
				p->zero = r;
			} else {
				p->one = r;
			}
			free (q);
			moto_cell_num--;
			collect_moto_cell (p, r, d);
		} else {           /* äƤϤʤ */
			r = n;
			s = r->zero;
			collect_moto_cell (r, s, 0);
		}
		return;
	} else if (n->zero==NULL && n->one!=NULL) {
		if (n->file==-1) {
			q = n;
			r = n->one;
			if (d==0) {
				p->zero = r;
			} else {
				p->one = r;
			}
			free (q);
			moto_cell_num--;
			collect_moto_cell (p, r, d);
		} else {
			r = n;
			s = r->one;
			collect_moto_cell (r, s, 1);
		}
		return;
	} else if (n->zero!=NULL && n->one!=NULL) {
		r = n;
		s = n->zero;
		collect_moto_cell (r, s, 0);
		r = n;
		s = n->one;
		collect_moto_cell (r, s, 1);
		return;
	}
}

void bitter (word, mode)
    char *word;
    int  mode;
{
	int i, j, x, k, l, pos;
	struct moto_cell *a, *b, *c, *p, *n;

	j = strlen(word);
	l = 0;

	if (node_moto_cell==NULL) {
		if ((a = (struct moto_cell *)calloc((size_t)1, sizeof(*a)))==NULL) 
		    merror ("node_moto_cell");
		a->pos  = 0;
		a->ck   = 0;
		a->zero = NULL;
		a->one  = NULL;
		a->file = -1;
		node_moto_cell = a;
		moto_cell_num++;
	}
	a = node_moto_cell;
	pos = 0;
	for (i=0; i<j; i++) {
		x = word[i];
		for (k=0; k<8; k++) {
			pos++;
			if (x & (1 << (7-k))) {
				if (a->one == NULL) {
					if ((b = (struct moto_cell *)calloc
					     ((size_t)1, sizeof(*b)))==NULL)
					    merror ("moto_cell b");
					b->pos  = pos;
					b->ck   = 0;
					b->zero = NULL;
					b->one  = NULL;
					b->file = -1;
					b->ptr  = (off_t)-1;
					a->one = b;
					moto_cell_num++;
				}
				c = a;
				a = a->one;
				if (debug==1)	printf ("1");
			} else {
				if (a->zero == NULL) {
					if ((b = (struct moto_cell *)calloc
					     ((size_t)1, sizeof(*b)))==NULL)
					    merror ("moto_cell b");
					b->pos  = pos;
					b->ck   = 0;
					b->zero = NULL;
					b->one  = NULL;
					b->file = -1;
					b->ptr  = (off_t)-1;
					a->zero = b;
					moto_cell_num++;
				}
				if (mode!=1 && a->one!=NULL) {
					collect_moto_cell (a, a->one, 1);
					if (a->one!=NULL)
					    a->one->ck = 1;
				}
				c = a;
				a = a->zero;
				if (debug==1)	printf ("0");
			}
		}
		l++;
		if (debug==1) {
			if (l==2) {
				printf ("\n");
				l=0;
			}
		}
	}
	a->file = 1;
	if ((a->term = (char *)calloc((size_t)(strlen(word)+1), sizeof(char)))==NULL)
	    merror ("a->term");
	strcpy (a->term, word);

	fflush (stdout);
	a->ptr = pointerA;
	if (debug==1) {
		printf ("%s ", a->term);
		printf ("position = %p", a);
		printf (" ....->ptr = %p\n", a->ptr);
		fflush (stdout);
	}
}

void collect_moto_cell_last ()
{
	collect_moto_cell (node_moto_cell, node_moto_cell->one, 1);
	collect_moto_cell (node_moto_cell, node_moto_cell->zero, 0);
}

void write_wan_type_int_char (word, num, str, wfwan)
     char *word;
     int num;
     char *str;
     FILE *wfwan;
{
	fwrite (word, (size_t)(strlen(word)+1), (size_t)1, wfwan);
	fwrite (&num, sizeof(int), (size_t)1, wfwan);
	fwrite (str, (size_t)(strlen(str)+1), (size_t)1, wfwan);
	pointerA = ftell(wfwan);
}

void write_wan_type_int(word, num, wfwan)
     char *word;
     int num;
     FILE *wfwan;
{
	fwrite (word, (size_t)(strlen(word)+1), (size_t)1, wfwan);
	fwrite (&num, sizeof(int), (size_t)1, wfwan);
	pointerA = ftell(wfwan);
}

void write_wan_type_double(word, dbl, wfwan)
     char *word;
     double dbl;
     FILE *wfwan;
{
	fwrite (word, (size_t)(strlen(word)+1), (size_t)1, wfwan);
	fwrite (&dbl, sizeof(double), (size_t)1, wfwan);
	pointerA = ftell(wfwan);
}

void write_wan_type_char (word, str, wfwan)
     char *word;
     char *str;
     FILE *wfwan;
{
	fwrite (word, (size_t)(strlen(word)+1), (size_t)1, wfwan);
	fwrite (str, (size_t)(strlen(str)+1), (size_t)1, wfwan);
	pointerA = ftell(wfwan);
}

void write_wan_type_ptr (word, ids, idct, wfwan)
     char *word;
     off_t *ids;
     int   idct;
     FILE *wfwan;
{
	int i;

	fwrite (word, (size_t)(strlen(word)+1), (size_t)1, wfwan);
	fwrite (&idct, sizeof(int), (size_t)1, wfwan);
	if (debug==1)  {
		printf ("idct = %d\n", idct);
	}
	for (i=0; i<idct; i++) {
		fwrite (&ids[i], sizeof(off_t), (size_t)1, wfwan);
		if (debug==1) {
			printf ("!!%p:", ids[i]);
			fflush (stdout);
		}
	}
	if (debug==1) {
		printf ("\n");
		printf ("\n");
		fflush (stdout);
	}
	pointerA = ftell(wfwan);
}

void check (a)
     struct moto_cell *a;
{
	printf ("POS:%d", a->pos);
	if (a->file==1)
	    printf ("\tTERM:%s", a->term);
	printf ("\n");
	if (a->zero==NULL && a->one==NULL) return;
	if (a->zero!=NULL) check (a->zero);
	if (a->one !=NULL) check (a->one);
	return;
}

void make_patrash_array ()
{
    	if ((wanwan = (struct patrash_array *)
	     calloc ((size_t)(moto_cell_num+1), (size_t)sizeof(struct patrash_array)))
	    ==NULL) merror ("patrash");
}

void fill_patrash_array (a)
     struct moto_cell *a;
{
	int my_cell_id;
	moto_cell_id++;
	my_cell_id = moto_cell_id;

	if (debug==1) {
		printf ("moto_cell_id = %d\n", moto_cell_id);
	}
	wanwan[my_cell_id].pos = a->pos;
/*	if (a->ptr!=(off_t)-1) {*/
	if (a->file==1) {
		wanwan[my_cell_id].ptr = a->ptr;
	} else {
		wanwan[my_cell_id].ptr = (off_t)-1;
	}
	if (a->zero==NULL && a->one==NULL) {
		wanwan[my_cell_id].zero = 0;
		wanwan[my_cell_id].one  = 0;
	} if (a->zero!=NULL && a->one!=NULL) {
		wanwan[my_cell_id].zero = my_cell_id+1;
		fill_patrash_array (a->zero);
		wanwan[my_cell_id].one  = moto_cell_id+1;
		fill_patrash_array (a->one);
	} else if (a->zero!=NULL) {
		wanwan[my_cell_id].zero = my_cell_id+1;
		fill_patrash_array (a->zero);
		wanwan[my_cell_id].one  = 0;
	} else if (a->one!=NULL) {
		wanwan[my_cell_id].zero = 0;
		wanwan[my_cell_id].one = moto_cell_id+1;
		fill_patrash_array (a->one);
	}
	return;
}	

void outp_patrash_array (wfidx)
     FILE *wfidx;
{
	int i;

	if (debug==1) {
		printf ("  0|  0|  0|%3d\n", moto_cell_id);
	}

	wanwan[0].pos = moto_cell_id;
	wanwan[0].zero= 0;
	wanwan[0].one = 0;
	wanwan[0].ptr = (off_t)-1;

	fflush(stdout);
	fwrite(&wanwan[0], sizeof(struct patrash_array), (size_t)1, wfidx);
	for (i=1; i<=moto_cell_id; i++) {
		if (debug==1){ 
			printf ("%3d .. %3d|%3d|%3d|%p\n", 
				i,
				wanwan[i].pos,
				wanwan[i].zero,
				wanwan[i].one,
				wanwan[i].ptr);
			fflush(stdout);
		}
		fwrite(&wanwan[i], sizeof(struct patrash_array), (size_t)1, wfidx);
	}
}

void output_patrash_array (wfidx)
    FILE *wfidx;
{
	make_patrash_array ();
	fill_patrash_array (node_moto_cell);
	outp_patrash_array (wfidx);/*node_moto_cell);*/
}	

FILE *bopen_patrash_wan (wfnwan)
     char *wfnwan;
{
	FILE *f;

	if ((f = fopen(wfnwan, "w+b"))==NULL) {
		fprintf (stderr, "cannot open %s\n", wfnwan);
		exit(1);
	}
	pointerA = (off_t)0;
	return f;
}

FILE *bopen_patrash_idx (wfnidx)
     char *wfnidx;
{
	FILE *f;
	if ((f = fopen(wfnidx, "w+b"))==NULL) {
		fprintf (stderr, "cannot open %s\n", wfnidx);
		exit(1);
	}
	pointerB = (off_t)0;
	return f;
}
