/*
 * mrpfil.c
 *
 * Copyright (c) 1998-2000,2001 Hajime Mochizuki <motizuki@jaist.ac.jp>
 *   Natural Language Processing Laboratory,
 *   Japan Advanced Institute of Science and Technology.
 *
 *
 * Use of this software is granted only for RESEARCH PURPOSES. 
 * Redistribution is granted as long as all copyright notices are retained.
 * Redistribution with modification is allowed provided that you make your 
 * modified version obviously distinguishable from the original one.  
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR 
 * IMPLIED WARRANTIES ARE DISCLAIMED.
 *
 *
 */
#include <config.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
/* #include "cmn.h"*/
#include "mrpfil.h"
/* #include "mdef_rule.h"*/ /* -DDEF_MRULE_POS=\"$(pkgdatadir)/rules\" */

extern void splitdata();
struct part_rl *prl=NULL;

CHAFLT_OUT *chaflt_out;        /* ͭñ */
int chaflt_out_num;
int number_of_words = 1;

char postp[10];
static int state=0;

/*
 * mrp_ana 
 */
struct mrp_ana* cal_mrp_ana (num)
     int num;
{
	struct mrp_ana *ma;

	if ((ma=calloc(num, sizeof(*ma)))==NULL) {
		fprintf (stderr, "calloc for ma error\n");
		exit(1);
	}
	
	return ma;
}

struct mrp_ana* ral_mrp_ana (ma, to)
     struct mrp_ana *ma;
     int to;
{
	struct mrp_ana *tmp;
	
	if ((tmp=realloc(ma, sizeof(*tmp)*to))==NULL) {
		fprintf (stderr, "realloc error for mp\n");
		exit(1);
	}
	return tmp;
}

/*
 * 01.04.27ɲ 褿Τǡʤѡ
 * ޤǽ˰ƤФʤȤʤʤؿ
 *
 */
void  set_mrp_rules (mrp_type, mrf) 
     int mrp_type;
     char *mrf;
{
	int i, j, k, soeji, pre, rls, sz;
	FILE *fp;
	char mrl[250], d[12][MORPHMAXLEN], buf[BUFSIZ];
	struct mrp_ana *ma;
	
	if (mrf==NULL) { /* ľܤΥե꤬ʤ */
		switch (mrp_type) {
		case 0:
			sprintf(mrl, "%s/mrule0", DEF_MRULE_POS);
			break;
		case 1:
		case 2:
			sprintf(mrl, "%s/mrule1", DEF_MRULE_POS);
			break;
		case 3:
			sprintf(mrl, "%s/mrule3", DEF_MRULE_POS);
			break;
		case 4:
			sprintf(mrl, "%s/mrule4", DEF_MRULE_POS);
			break;
		default:
			sprintf(mrl, "%s/mrule0", DEF_MRULE_POS);
			break;
		}
	} else {
		sprintf (mrl, "%s", mrf);
	}

	if ((fp=fopen(mrl, "r"))==NULL) {
		fprintf (stderr, "cannot open %s\n", mrl);
		exit(1);
	}
	if ((prl=calloc(PARTNUM,sizeof(*prl)))==NULL) {
		fprintf (stderr, "calloc for prl error\n");
		exit(1);
	}
	for (i=0; i<PARTNUM; i++) { /*  */
		prl[i].word[0]='d';
		prl[i].word[1]='\0';
		prl[i].rule_ct=0;
		prl[i].ma=NULL;
	}

	soeji=-1; rls=0;
	while(fgets(buf, BUFSIZ, fp)!=NULL) {
		if(buf[0]=='#') continue;/*  */
		buf[strlen(buf)-1]='\0';
		if (buf[0]==';') {
			if (soeji!=-1) {
				prl[soeji].rule_ct = rls; rls=0;
				prl[soeji].ma = ma;
			}
			/* ν񤤤ƤʻϤȤˤȤ */
			if (strcmp(buf, ";̾")==0) {
				soeji=PARTNOUN;
			} else if(strcmp(buf, ";ƻ")==0) {
				soeji=PARTADJ;
			} else if(strcmp(buf, ";ư")==0) {
				soeji=PARTVERB;	
			} else if(strcmp(buf, ";̤")==0) {
				soeji=PARTUNKN;
			} else if(strcmp(buf, ";")==0) {
				soeji=PARTPOST;
			}
			fgets(buf, BUFSIZ, fp);
			buf[strlen(buf)-1]='\0';
			for (i=0; i<3; i++) {
				d[i][0]='\0';
				splitdata(d[i], buf, '\t');
			}
			strcpy(prl[soeji].word, d[2]);
		} else {
			for (i=0; buf[0]!='\0'; i++) {
				d[i][0]='\0';
				splitdata(d[i], buf, '\t');
			}
			if (rls==0) {
				ma = cal_mrp_ana(MRULEADD); /* Ȥꤢ 5 */
				sz = MRULEADD;
			} else if (rls>=sz) {
				ma = ral_mrp_ana(ma, sz+MRULEADD);
				sz+= MRULEADD;
			}
			strcpy(ma[rls].action, d[0]);
			for (j=1; j<i; j=j+2) {
				ma[rls].fld[j]=atoi(d[j]);
				strcpy(ma[rls].words[j], d[(j+1)]);
			}
			ma[rls].fld[0]=i/2;
			rls++;
		}
	}
	if (soeji!=-1) {
		prl[soeji].rule_ct = rls; rls=0;
		prl[soeji].ma = ma;
	}
}


/*
 * sscanf ߤʽ
 * ǡΰ㤤ۼǤ褦ˡ˵Ҥ롥
 * ϳեǷƥϡɥǥ󥰤򤱤äɡ
 * 뤬ʤƤʤä
 *
 */
struct mrp_entry* like_sscanf(record, mrp_type)
     char *record;
     int mrp_type;
{
	int i, j;
	char d[12][MORPHMAXLEN];
	char p[150];
	char pp[5][MORPHMAXLEN];
	struct mrp_entry *me;

	if ((me=calloc(1,sizeof(*me)))==NULL) {
		fprintf (stderr, "calloc for c2d error\n");
		exit(1);
	}
	for (i=0; i<MORPHFIELDMAX; i++) me->field[i][0]='\0';

	switch (mrp_type) {
	case MRPTYPE_CHASEN:
		for(i=0; i<3; i++) {
			d[i][0]='\0';
			splitdata(d[i], record, '\t');
		}
		p[0]='\0';
		splitdata(p, record, ' ');
		for (i=0; p[0]!='\0'; i++) {
			pp[i][0]='\0';
			splitdata(pp[i], p, '-');
		}
		strcpy((me->field[0]), d[0]);
		strcpy((me->field[1]), d[1]);
		strcpy((me->field[2]), d[2]);
		for (j=0; j<i; j++) {
			strcpy((me->field[(j+3)]), pp[j]);
		}
		break;

	case MRPTYPE_KNP:
	case MRPTYPE_JUMAN:
		sscanf (record, "%s %s %s %s %s %s %s %s %s %s %s",  d[0], d[1], d[2],
			d[3], d[4], d[5], d[6], d[7], d[8], d[9], d[10]);
		strcpy((me->field[0]), d[0]);
		strcpy((me->field[1]), d[1]);
		strcpy((me->field[2]), d[2]);
		strcpy((me->field[3]), d[3]);
		strcpy((me->field[4]), d[5]);
		strcpy((me->field[5]), d[7]);		
		strcpy((me->field[6]), d[9]);
		break;
	}
	return me;
}

void chaflt_out_init()
{
    int i;

    if (chaflt_out_num >= 1) {
        for (i=0; i<chaflt_out_num; i++) {
                free (chaflt_out[i].term); chaflt_out[i].term=NULL;
        }
    }
    free (chaflt_out); chaflt_out=NULL;
    chaflt_out_num = 0;
}

int add_chaflt_out (term, sn, wn, num, pp, ppbase, realwn)
   char *term;
   int   sn, wn, num, realwn;
   char *pp, *ppbase;
{
	int i;
	CHAFLT_OUT *temp;
#ifdef TEST
	printf ("add in %s -- ", term);
#endif
	if (chaflt_out_num == 0) {
		if (!(chaflt_out = (CHAFLT_OUT *)malloc(sizeof(CHAFLT_OUT)))) {
			fprintf (stderr, "memory over\n");
			exit(1);
		}
	} else {
		if (!(temp=(CHAFLT_OUT *)realloc
		      (chaflt_out, sizeof(CHAFLT_OUT)*(chaflt_out_num+1)))) {
			fprintf (stderr, "memory over\n");
			exit(1);
		}
		else { chaflt_out = temp; }
	}
	if ((chaflt_out[chaflt_out_num].term = 
	     (char *)malloc(sizeof(char)*(strlen(term)+1)))==NULL) {
		fprintf (stderr, "malloc error for chaflt_out %s\n", term);
		exit(1);
	}
	strcpy (chaflt_out[chaflt_out_num].term, term);
	chaflt_out[chaflt_out_num].snum = sn;
	chaflt_out[chaflt_out_num].wnum = wn;
	chaflt_out[chaflt_out_num].realwn = realwn;
	chaflt_out[chaflt_out_num].number = num;
	strcpy (chaflt_out[chaflt_out_num].pp, pp);
	strcpy (chaflt_out[chaflt_out_num].ppbase, ppbase); /* ɲ 01/05/01 */
	num++;
	chaflt_out_num++;

#ifdef TEST
    printf ("out \n");
#endif
    return num;
}

void add_pp (number, pp, ppbase)
    int number;
    char *pp, *ppbase;
{
	strcpy (chaflt_out[number].pp, pp);
	strcpy (chaflt_out[number].ppbase, ppbase); /* ɲ 01/05/01 */
}

/*
 * filterϡmrp_type ˤäʬ褦ˤ
 * ꥹȤȤ⡤̥եǤ褦ˤʤäƤ롥
 * mrule0 , mrule1Ȥ̾Υե롥꾯ɤʤä
 */
int cha_posfilter (record, sn, wn, mode, realwn, mrp_type)
   char *record;
   int  sn;
   int  wn;
   int  mode, realwn, mrp_type;
{
	int  i, j, ck, len, d4, d6, ok, partofspeech;
	static char last[3];
	struct mrp_entry *me;
	struct mrp_ana *ma;
	char joshitype[10];

	me = like_sscanf(record, mrp_type);
	len = strlen(me->field[2]);
	ck = number_of_words;

	/* d4 = ʻʬࡤ d6 = ʬ */
	d4=-1;
	if ((mode<4) && strcmp(me->field[3], prl[PARTNOUN].word)==0) { /* ̾ */
		d4 = 6;
		d6 = 0;
		partofspeech=PARTNOUN;
	} else if ((mode<2||mode>4)&&
		   (strcmp(me->field[3], prl[PARTADJ].word)==0)){/* ƻ */
		d4=3;
		d6=0;
		partofspeech=PARTADJ;
	} else if ((mode<1||(mode>2 && mode<6)) && 
		   (strcmp(me->field[3], prl[PARTVERB].word)==0)) { /* ư */
		d4=2;
		d6=0;
		partofspeech=PARTVERB;
	} else if (strcmp(me->field[3], prl[PARTUNKN].word)==0) { /* ̤ */ 
		d4=6;	/* ̾Ʊ˰ */
		d6=0;
		partofspeech=PARTUNKN;
	} else if (strcmp(me->field[3], prl[PARTPOST].word)==0) { /*  */
		d4=9;
		partofspeech=PARTPOST;
	} else {
		partofspeech=-1;
	}
	if (partofspeech!=-1) {
		if (partofspeech==PARTPOST) {
			strcpy(joshitype, "no");
			for (i=0; i<prl[PARTPOST].rule_ct; i++) {
				ma = (prl+PARTPOST)->ma+i;
				ok = 1;
				for(j=1; j<=ma->fld[0]; j++) {
					if (strcmp(me->field[(ma->fld[j])], 
						   ma->words[j])!=0) {
						j=(ma->fld[0])+1;
						ok=0;
					}
				}
				if (ok) strcpy(joshitype, ma->action);
			}
		} else {
			for (i=0; i<prl[partofspeech].rule_ct; i++) {
				ma = (prl+partofspeech)->ma+i;
				ok = 1;
				for(j=1; j<=ma->fld[0]; j++) {
					if (strcmp(me->field[(ma->fld[j])], 
						   ma->words[j])!=0) {
						j=(ma->fld[0])+1;
						ok=0;
					}
				}
				if (ok) {
					d6 = atoi(ma->action); /* -1 Ƚ */
					/* 롼ɽ˰̣ */
					i=prl[partofspeech].rule_ct; 
				}
			}
		}
	}

	/* Ҥ餬1ʸ̾ϥå*/
	if (d4==6 && len==2 &&
	    (me->field[2][0]==0xffffffa4 || me->field[2][0]==0xffffffa5)) {
		/* return ck; */
		free(me);me=NULL;
		return wn;
	}
	if (d4==6 && d6==0) {/* for̾*/
		number_of_words = 
			add_chaflt_out(me->field[2],sn,wn,number_of_words,
				       "no","no",realwn);
		state = 1;
	} else if (d4==3 && d6==0) { /* for ƻ */
		j=0; last[0]='\0';
		if (len > 2) {
			for (i=len-2; i<len; i++) {
				last[j] = me->field[2][i]; j++;
			}
			last[2] = '\0';
			if (strcmp(last, "")==0 ) me->field[2][len-2]='\0';
		}
		number_of_words = 
		     add_chaflt_out(me->field[2],sn,wn,number_of_words,
				    "yogen","no",realwn);
		state = 0;
	} else if (d4==2 && d6==0) { /* for ư */
		number_of_words = 
			add_chaflt_out(me->field[2],sn,wn,number_of_words,
				       "yogen","no",realwn);
		state = 0;
	} else if (d4==9) { /* for  */
		/*
		  if ((strcmp(d[5], "ʽ")==0) &&
		  (strcmp(d[0], "")!=0)) {
		  if (strcmp(d[0], "")==0)
				 strcpy(joshi, "gashugo");
			    else if (strcmp(d[0], "")==0)
				 strcpy(joshi, "wotsuki");
			    else
				 strcpy(joshi, "kakujoshi");
		} else if (strcmp(d[5], "")==0) {
			if (strcmp(d[0], "")==0)
			     strcpy(joshi, "hashugo");
			else if (strcmp(d[0], "")==0)
			     strcpy(joshi, "motsuki");
			else
			     strcpy(joshi, "fukujoshi");
		}
		else if ((strcmp(d[5], "̾³")==0) &&
			 (strcmp(d[0], "")==0)) {
			strcpy(joshi, "kakujoshi");
		} else 
		     state = 0;
  	        */

		strcpy(postp, joshitype); /* ѹޤ */

		if (state!=0&&chaflt_out_num>0) {
			add_pp (chaflt_out_num-1, postp, me->field[2]);
		}
	}
	if (ck!=number_of_words) {wn++;}
	free(me); me=NULL;
	return wn;
}

/*
 * cha_inǲϤޤƤʤǡǤν
 */
CHAFLT_OUT *direct_chaflt (cha_in, sn, allmrp, mode, mrp_type, mrf)
    char *cha_in, *mrf;
    int  sn;        /* sentence no */
    int  mode, mrp_type, *allmrp;
{
    int i, wn, realwn, am;
    char d[BUFSIZ];

    if (prl==NULL) set_mrp_rules (mrp_type, mrf);

    am=*allmrp;
    chaflt_out_num = 0;
    wn = realwn = 1;
    for (i=0; cha_in[0]!='\0'; i++) {
        d[0]='\0';
        splitdata (d, cha_in, '\n');
        if (strcmp(d,"EOS")!=0) {
                wn = cha_posfilter (d, sn, wn, mode, realwn, mrp_type);
                realwn++;
		am++;
        }
    }
    *allmrp=am;
    return chaflt_out;
}


/*
 * cha_inǲϺѤߤΥǡǤν
 */
CHAFLT_OUT *indirect_chaflt (cha_in, sn, wn, mode, realwn, mrp_type, mrf)
    char *cha_in;
    int sn, *wn;
    int mode, realwn, mrp_type;
    char *mrf;
{
    int wnum;

    wnum=*wn;

    if (prl==NULL) set_mrp_rules (mrp_type, mrf);
    wnum = cha_posfilter (cha_in, sn, wnum, mode, realwn, mrp_type);
    *wn=wnum;
    return chaflt_out;
}
